<?php

  /////////////////////////////////////////////////
  //  ICAL
  /////////////////////////////////////////////////

  function ical () {
	
	// Choix des dates à prendre en compte, incluant le jour courant
	$nb_jours = 7;
	$jours = date('Ymd');
	for($i=1 ; $i < $nb_jours ; ++$i)
	{
		$jours .= '|'.date('Ymd', mktime(0, 0, 0, date('m'), date('d')+$i, date('Y')));
	}
	
	// Récupération des données brutes de X calendriers
	// ou, pour un seul fichier .ics :
	// $calendrier = file_get_contents("nom_du_fichier.ics");
	$ics_cals = array(
		'calendrier1.ics',
		'calendrier2.ics',
		'calendrier3.ics',
		'calendrier4.ics'
		);
	$calendrier = '';
	foreach($ics_cals as $val)
	{
		$calendrier .= file_get_contents('ical/'.$val);
	}
		
	// Extraction des données utiles = date + evenement
	$regExpMatch = '#SUMMARY:(.*)\nDTSTART;.*:(('.$jours.').*)#';
	$n = preg_match_all($regExpMatch, $calendrier, $matchTableau, PREG_PATTERN_ORDER);
	
	//echo("n = ".$n."<br />");	//Impression du nb de résultats pour contrôle
	//print_r($matchTableau);	//Impression du tableau de résultat brut pour contrôle
	
	// Récupération des données sous forme d'un tableau
	// dont la clé = la date
	for ($j=0 ; $j < $n ; ++$j)
	{
		// Récupération des données
		$date = $matchTableau[2][$j];
		$detail = $matchTableau[1][$j];
		$cal[$date] = $detail;
	}
	// Tri des données par date (clé) ascendante
	ksort($cal);
	
	// Exploitation des données triées
	$html = '';
	$date0 = '';
	foreach($cal as $date=>$detail)
	{
		// Mise en forme des dates
		$annee = substr($date, 0, 4);
		$mois = substr($date, 4, 2);
		$jour = substr($date, 6, 2);
		$heure = '';
		if(substr($date, 9)!='')
		{
			$heure = substr($date, 9, 2).'h'.substr($date, 11,2);
		}
		$date = $jour.'/'.$mois.'/'.$annee;
		// Non répétition de la date si identique à l'événement n-1
		if($date == $date0)
		{
			$date = '';
		}
		$date0 = $date;
		
		//Affichage
		$html .= '<div class="ical_event">
			<div class="ical_date">'.$date.'</div>
			<div class="ical_detail">'.$detail.'</div>
			<div class="ical_heure">'.$heure.'</div>
			</div>';
	}
	
    return $html;
  }

?>
